{by RJO 2016.  Terms of use:  ALL of the objects used are covered by the usual licenses.  The original code here is free to use for any purpose,
without restrictions or attribution.  If you can make a buck... go do it:O)
This is specifically written for the SIM808... setup for a Propeller Activity Board.  All SIM808 modules are not equal.
Even though all have hardware for GSM,Bluetooth and GPS, the firmware on some is old and does not actually support Bluetooth.
In fact, the unit that I eventually found found to work was also the cheapest available.   http://www.ebay.com/itm/SIM808-Wireless-Board-GPS-GSM-GPRS-Bluetooth-Module-replace-SIM908-K85-/222195011671
$18.55

In theory you can update the SIM808 firmware.  In fact the software to do this is only in the hands of
those distributors that asked for it.  And none of those seems to have made it available to the public.
I have tried this project code on SIM800 modules, which are smaller and cheaper, but without  bluetooth or GPS.
Aside from reporting a lot of errors from the missing hardware, it works fine.  You can control the SIM800 using AT commands through
the Parallax Serial Terminal... $5 cell phone module.  Not bad.
I have a couple of different boards from the SIM800 family on order that supposedly support Bluetooth but have no GPS.  We'll see.

What the current version presently does well:
1. track gps and store the data to micro sd card.
2. Send current location of the unit to a Base Phone via SMS
3. Make and recieve voice calls using a Bluetooth speakerphone for both mic and speaker... Walmart $20

Not so good:
4. Supports a $5 OLED , but nothing currently implemented for phone services... menu, time, signal, battery, etc all not implemented.
http://www.ebay.com/itm/0-96-inch-SPI-Serial-128x64-OLED-LCD-Display-White-Screen-Module-For-Arduino-/331906426673
the driver chip is SSH1106, but this is compatible with the SSD1306 software for Parallax's Hackable Badge.  That object was renamed and is included.
Plans:
  Email full tracking info ...
  Some phone input device other than a key board or serial terminal... I have a lot of ideas, but I'll be surprised
  if any of them come to fruition:)
  A Propeller utility to convert the raw GPS tracking info to 
}
CON
  _clkmode = xtal1 + pll16x                                                    
  _xinfreq = 5_000_000

  
  Ser2Rx      =  0
  Ser2Tx      =  1
  DebugRx       = 31            ' Serial interface via Prop Clip, IN from user
  DebugTx       = 30
  CR          = 13
  controlz =26
  OLED_CLK = 11
  OLED_DAT = OLED_CLK+1
  OLED_RST = OLED_CLK+2 
  OLED_DC  = OLED_CLK+3
  OLED_CS  = OLED_CLK+4  
                                                   ' OLED connections 
  SDBASE = 22
  DO  = 22                               '' DO  = 22   
  CLK = 23                               '' CLK = 23   
  DI  = 24                               '' DI  = 24   
  CS  = 25                               '' CS  = 25   
  CD  = -1                               '' CD  = -1   
  WP  = -1                               '' WP  = -1   
  rt1 = -1                               '' rt1 = -1   
  rt2 = -1                               '' rt2 = -1   
  rt3 = -1                               '' rt3 = -1   
                                         ''
            
OBJ
    debug:  "FullDuplexSerial"
    ser2: "FullDuplexSerial"
    oled : "OLED1306mono_AsmFast"
    sdfat : "SD-MMC_FATEngine"   
var
    long temp,exp,counter,counter1,timer1,timer2,cc,r,smscounter,smstart,checksum,trackingon,trackInterval,elapsed
    long sig,start,myresult,vgain,numchars,count,ii,i,trapsms,exists,filename,report,trackANDreport
    byte tbuf[20]  
    byte datafromsim808[140]
    byte datem[8]
    byte smsdata[200] 
Pub Main
  waitcnt(clkfreq*3 + cnt)                    'time to enable serial (debug) terminal
  Assign_Vars
  Start_Serial      
  Start_OLED
  Start_SDservices
  Start_Sim808
  repeat
    timer1:=cnt                  'This outer loop   is used for timing purposes requires minimal code:)
    repeat 5000                 '5000 repeats is about 40 seconds.  We are squaring off the seconds so it doesn't turn out to be exact... the more repeats
                                 'the closer we get
                                 'this loop handles communications between the Prop and the Phone
                                 
       temp:=debug.rxtime(1)        'look at debug for input, but don't wait
       if temp>-1
    
          ser2.tx(temp)
       temp:=ser2.rxtime(1)              'look at the sim808 serial line(Ser2)but don't wait  This isn't perfect, but it works pretty well 
                                         'unless you push the buad rate on the Sim808.  9600 Baud works fine
                                          

       repeat while temp > -1             'once something is detectdd, loop until there is no activity.  This misses an occasional character
                                          ' fixing it caused problems
    
         temp:=ser2.rxtime(1)              'there is a little logic issue in the blank space between the two lines:)
         if temp > -1                      ' I might come back to it.  But it is working ALMOST perfectly so.. later.  
           debug.tx(temp)
           if temp ==43
            counter:=0
       
           datafromsim808[counter]:=temp          'an array to temporarily hold input from the sim808 serial input
           counter++
           if (temp == 13) and (counter > 10)      'at the end of every ser2 input line, look to see if the line is over 10 characters and if so, branch to trap_reply
             trap_reply                              'right now we are only watching for incoming text messages and if found look at them for instrutions to the Prop.
    if trackingOn==1           
        timer2:=cnt
        elapsed:=elapsed+((timer2-timer1)/80000000 )
        debug.str(string("elapsed seconds = "))
        debug.dec(elapsed)
        debug.tx(13)
        if elapsed>trackInterval
          elapsed:=0
          SendAndOrStore_GNSS 
          
Pub Assign_vars
     trapsms:=0                      'legacy:)
     trackingon:=0
     trackInterval:=300   'seconds     how long between GPS fixes.  
     elapsed:=0
     trackAndreport:=0
     report:=0  
Pub Start_Serial

  debug.start(DebugRx,DebugTx,0,115200)

  ser2.start(Ser2Rx,Ser2Tx,0,9600)                    'note the baud rate between the phone and the Prop... if we don't slow it down, there isn't enough
                                                      'time for the Prop to do some of the stuff it wants to.  
  waitcnt(clkfreq/3 + cnt) 
Pub Start_OLED
  oled.init(OLED_CS, OLED_DC, OLED_DAT, OLED_CLK, OLED_RST, oled#SSD1306_SWITCHCAPVCC, oled#TYPE_128X64)   '
   ' start buffered oled driver
  
  oled.AutoUpdateOn
  
  draw_oled
Pub Start_SDservices
  sdfat.fatEngineStop
  sdfat.fatEngineStart( DO, CLK, DI, CS, WP, CD, {
                    } RT1, RT2, RT3)

   if(sdfat.partitionMounted)
    \sdfat.unmountPartition 
  debug.str(string("DEBUG",cr))

  r:=\sdfat.unmountPartition
  r:=\sdfat.mountPartition(0)
  debug.str(string("partition 0 mounted with return="))
  r:=\sdfat.unmountPartition   
  debug.dec(r)
  test_sd

Pub Start_Sim808

  waitcnt(clkfreq*5+cnt)
 ' start_fs
 
 ' repeat
  trackingon:=0

  ser2.str(string("AT",cr))
  wait_ser2 
 
  'debug.str(string(@quote))
  ser2.str(string("AT+IPR=9600",cr))            'turn auto-bauding on     AT+IPR=0
  wait_ser2
  ser2.str(string("AT+CLIP=1",cr))
  wait_ser2
  ser2.str(string("ATE1",cr )) 'ate1=echo on ate0 =echo off
  wait_ser2
  debug.str(string("Echo ON",cr))    
  ser2.str(string("AT+CMEE=2",cr )) 'full error reporting  verbose
  wait_ser2
  
  ser2.str(string("AT+CNMI=2,1,0,0,0",cr))        '''set new message indications
  wait_ser2
  ser2.str(string("AT+CMEE=2",cr )) 'full error reporting  verbose
  wait_ser2
  ser2.str(string("AT+CMGF=1",cr))       'set sms encoding to text mode
  wait_ser2
  ser2.str(string("AT+cmgr=1",cr))         'read sms message number 1
  wait_ser2
  wait_ser2
  ser2.str(string("AT+CGNSPWR=1",cr))               'turn gps on
  wait_ser2
  ser2.str(string("AT+BTPOWER=1",cr))
  wait_ser2
  
  ser2.str(string("at+cgnsinf",cr))               'get location,course, satellites, etc
  wait_ser2

  ser2.str(string("AT+CSCS?",cr))
  waitcnt(clkfreq/3 + cnt)

  ser2.str(string("AT+CMGF=1",cr))       'set sms encoding to text mode
  wait_ser2
 ' ser2.str(string("AT+CSCS=",quote,"GSM",quote,cr))
 ' wait_ser2
  ser2.str(string("at+cmgs="))
  ser2.str(@quote)
  ser2.str(@basePhone)
  ser2.str(@quote)
  ser2.str(string(cr))

  wait_ser2       'w:=sio.dec(temp)             'send whole number
  ser2.str(string("sim808pab02",controlz))

  wait_ser2
  wait_ser2
 
  ser2.str(string("ATE0",cr )) 'ate1=echo on ate0 =echo off
  wait_ser2
  
  debug.str(string("ECHO OFF",cr))
  debug.str(string(cr,"Sim808 READY",cr))
  wait_ser2  
Pub dir     : statusVal | statusStr    
  ifnot sdfat.partitionMounted
     r:=\sdfat.mountPartition(0)
  repeat while (statusVal := sdfat.listEntries("N")    )
    if statusVal
      debug.tx(13)
      debug.str(statusVal)
 
  debug.tx(13)   
Pub file_exists(newfilename,mode) 
           ifnot sdfat.partitionMounted
               r:=\sdfat.mountPartition(0)
   
           
           r:=\sdfat.newFile(newfilename)
   
            
           return r
Pub test_sd     : statusVal | statusStr   
        dir
     

Pub SendAndOrStore_GNSS
      Get_GNSS
      if report==1
                       ser2.str(string("at+cmgs="))                 'if reporting is turned on... a copy of the GPS transaction is sent to the base phone number
                       ser2.str(@quote)
                       ser2.str(@basePhone)
                       ser2.str(@quote)
                       ser2.str(string(cr))
                       waitcnt(clkfreq/2 + cnt)
                       debug.tx(13)
                       debug.str(string("SENDING",cr))
         
                 
                       debug.tx(13)
                                
                       wait_ser2
                       wait_ser2
                       counter:=0
                       repeat 99
                           ser2.tx(datafromsim808[counter])
                           counter++
                       ser2.str(string(controlz))
                       waitcnt(clkfreq*7 + cnt)
          debug.tx(13)
          debug.str(string ("Active file: "))                        'if reporting is on... every GPS transaction gets stored... 
          repeat i from 6 to 13
                       debug.tx( datafromsim808[i] )                'files are named  as 8 characters(yymmddhh) parsed from the utc... 
                       counter := 0                                 'So, each file contains whatever was stored in that hour
          debug.str(string(".TXT"))
          debug.tx(13)
          temp:=ser2.rxtime(1)
    
Pub trap_reply
    if (datafromsim808[2]=="M" )  and (datafromsim808[3]=="T" )                   ''is it a text message?
                  ii:=0
                  debug.str(string("sms trapped",cr))                             'blah
                  repeat counter-1
                      debug.tx(datafromsim808[ii])
                      ii++
                  cmgr[8] := datafromsim808[12]
                  cmgr[9] := datafromsim808[13]
                  trapsms:=1
                  smscounter:=0   
                  ser2.str(@cmgr)
                  ser2.tx(13)
                  wait_ser2                                                        'blah
                  trapsms:=1  
                  wait_ser2      
                  debug.tx(13)
                  temp:=0
                  ii:=0                                                                'blah
                  repeat until temp==13
                     temp:=smsdata[ii]
                     ii++
                  temp:=0
                  repeat until temp==13
                     temp:=smsdata[ii]
                     ii++
                  temp:=0
                  ii++
                  debug.str(string("AND YOUR SMS IS..."))                          'blah d blah d blah blah blah
                  smstart:=ii
                  smscounter:=smscounter-ii
                  repeat smscounter
                   
                    debug.tx(smsdata[ii])
                    'debug.dec(smsdata[ii])
                    ii++
                  {
                  debug.str(string("total character count="))
                  debug.dec(ii-1)
                  debug.tx(13)
                     }
                     
                  trapsms:=0
                  {
                  debug.str(string("   actual first character is "))
                  debug.tx(smsdata[smstart])
                
                  debug.tx(10)
                  debug.str(string("   actual last character is "))
                  debug.tx(smsdata[ii-9])
                  'debug.dec(smsdata[ii-9])
                  } 
                  ii:=smstart
                  checksum:=0
                  repeat 5
                    checksum:=checksum+smsdata[ii]
                    ii++
                  {
                  debug.str(string("checksum5 = "))
                  debug.dec(checksum)
                  debug.tx(10)
                   }
                  
                  waitcnt(clkfreq/3 + cnt)
                  counter:=0
                  if checksum==240                                               'is it 00000?
                    report:=1
                    SendAndOrStore_GNSS
                    report:=0                                                 'is it 11111?
                  if checksum==245
                     trackingon:=1
                     report:=0
                     debug.str(string("tracking on/reporting off"))
                     debug.tx(13)
                     debug.tx(10)
                     timer1:=cnt                                         'is it 22222?
                  if checksum==250
                     trackingon:=1
                     report:=1
                     debug.str(string("tracking on/reporting on"))
                     debug.tx(13)
                     debug.tx(10)
                  if checksum==255                                         'you get the picture
                     trackingon:=0
                     report:=0
                     debug.str(string("tracking off/reporting off"))
                     debug.tx(13)
                     debug.tx(10)
   
Pub wait_ser2
   temp:=0
  
   repeat until temp == -1

          temp:=ser2.rxtime(1200)                                'you have to wait ... but you don't want to wait to long... and certainly not forever
          if temp > -1
            debug.tx(temp)
            if trapsms==1
              smsdata[smscounter]:=temp
              smscounter++
           
           'debug.dec(temp)
Pub Track

   
Pub Get_GNSS

  parseGNSS 

Pub parseGNSS | parsecount
     parsecount:=0
     ser2.str(string("at+cgnsinf",cr))
     temp:=0
     repeat until temp==13
       temp:=ser2.rx
     temp:=0

     repeat 11
       temp:=ser2.rx
       'debug.tx(temp)
       
     
     repeat 94
       temp:=ser2.rxtime(100)
       'debug.tx(temp)
       datafromsim808[parsecount]:=temp
       parsecount++
     debug.tx(13)
     parsecount:=0
     debug.str(string("data to debug terminal and sdfat   ",cr))
    
     
     repeat 8
         datem[parsecount]:=  datafromsim808[parsecount+6]
         parsecount++
      bytemove(@datehour,@datem,8)
     r:=\sdfat.newFile(@datehour)      
     r := \sdfat.openFile(@datehour,"A")
      
     if r>0
         debug.str(string("sdfat error on opening file",cr))                             'this doesn't work... wrong test, so always says that there is an erro
                                                                                         ' I tried to fix this, spent a lot time trying... interesting ... left to mind me I need it
     parsecount:=12
     debug.str(string("data being stored:=  "))  
     repeat 4
    
       debug.tx(datafromsim808[parsecount])
       sdfat.writeByte (datafromsim808[parsecount])
       parsecount++
     parsecount:=parsecount+6
     
     repeat 62
        debug.tx(datafromsim808[parsecount])
        sdfat.writeByte (datafromsim808[parsecount])
        parsecount++
     sdfat.writeByte (13)     
     sdfat.closeFile
     debug.tx(13)
    

Pub draw_oled                                                             'object code comes from the Parallax's Hackable badge ... drives a $4 mono 128x64 oled
                                                        'Not doing anything with it yet... just leaving it there for now.  Will probably take it off the tracker and
                                                        'just use it on the phone variant.

     oled.write5x7Char("Y",0,0)
     oled.line(2,6,2,8,1)
     oled.line(2,8,8,8,1)
     oled.box(110,1, 120,7,1)
     oled.box(108,3,110,5,1)
     oled.line(111,2,111,6,1)
     oled.line(112,2,112,6,1)
     oled.write4x16String(string("PropPhone 2.0"),13,3,0)
     
     oled.write16x32Char("!",1,3)       'char,row,col   
  vgain:=0
  counter:=0


      
DAT
quote  byte  $22,0
basePhone byte "8154888336",0
datehour byte "00000000.TXT", 0
cmgr byte "AT+cmgr=14",0  